package com.zipcodewilmington.generic.group;

import com.zipcodewilmington.generic.identifiables.IdentifiableInterface;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.lang.reflect.ParameterizedType;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.function.Predicate;
import java.util.stream.Collectors;

/**
 * @author leon on 06/12/2018.
 */
public class Group<TypeOfId extends Serializable,
        TypeOfEntity extends IdentifiableInterface<TypeOfId> >
        extends AbstractGroup<TypeOfId,TypeOfEntity>{

 List<TypeOfEntity> myGenList;

    public Group() {
        myGenList= new ArrayList<>();
    }

    @Override
    public Integer count() {
        return myGenList.size();
    }



    @Override
    public void insert(IdentifiableInterface object) {
        myGenList.add((TypeOfEntity) object);

    }

    @Override
    public void delete(IdentifiableInterface object) {

        myGenList.remove(object);

    }

    @Override
    public void delete(Serializable serializable) {
       while (myGenList.iterator().hasNext()){
           if(myGenList.iterator().next().getIdentity()==serializable){
               myGenList.remove(myGenList.iterator().next());
           }
       }


    }

    @Override
    public Boolean has(IdentifiableInterface object) {
        return myGenList.contains(object);
    }

    @Override
    public Boolean has(Serializable serializable) {
        for (TypeOfEntity tOP : myGenList) {
            if (tOP.getIdentity()==serializable){
                return true;
            }


        }

        return false;
    }


    @Override
    public List<TypeOfEntity> filter(Predicate<TypeOfEntity> predicate) {
        return myGenList.stream()
                .filter(predicate)
                .collect(Collectors.toList());
    }


    @Override
    public Class<? extends TypeOfId> getIdentityType() {
        return null;
    }

    @Override
    public Class<? extends TypeOfEntity> getIdentifiableType() {
        return null;
    }



}
